/******************************************************************************/
#include "mtc3type.h"
#include "mtc3ext.h"
/******************************************************************************/
int Get_Iv_Map()
{
 Get_Iv_Elements();
 Print_Iv_Map();
 return(0);
}
/******************************************************************************/
/*              Get the interleaver map. Based on CB and AG.
*******************************************************************************/
int Get_Iv_Elements()
{
 int iv_inx,ir,jr,i,j,epsilon,p[8],map;
 Get_P_Map(p);
 for(iv_inx=ZERO;iv_inx<IV_SIZE;iv_inx++)
 {
  i=iv_inx/256;
  j=iv_inx%256;
  ir=(129*(i+j))%256;
  epsilon=(i+j)%8;
  jr=(p[epsilon]*(j+1)-1)%256;
  map=256*ir+jr;
  Iv_Map[iv_inx]=map;
  De_Iv_Map[map]=iv_inx;
 }
 return(0);
}
/******************************************************************************/
/*                      Get the mapping for an array.
*******************************************************************************/
int Get_P_Map(p)
int p[];
{
 p[0]=17;
 p[1]=37;
 p[2]=19;
 p[3]=29;
 p[4]=41;
 p[5]=23;
 p[6]=13;
 p[7]=7;
 return(0);
}
/******************************************************************************/
/*                       Print the interleaver map.
*******************************************************************************/
int Print_Iv_Map()
{
 int cnt;
 printf("\t Interleaver map.\n\n");
 for(cnt=ZERO;cnt<IV_SIZE;cnt++)
 {
  printf("\t\t Iv. map Index:%5d Map:%5d\n",cnt,Iv_Map[cnt]);
  printf("\t\t Dv. map Index:%5d Map:%5d\n",cnt,De_Iv_Map[cnt]);
 }
 printf("\n");
 fflush(stdout);
 return(0);
}
/******************************************************************************/
