/******************************************************************************/
/*                          COUNTER VARIABLES.
*******************************************************************************/
extern int Bits[FRAME_SIZE];                        /* No. of bits per frame. */
extern int Iv_Bits[FRAME_SIZE];         /* No. of interleaved bits per frame. */
extern int Frame_Cnt;                                         /* Frame count. */
extern int Bit_Cnt;                                             /* Bit count. */
extern int Ber;                                            /* Bit error rate. */
/******************************************************************************/
/*                             ENCODER VARIABLES.
*******************************************************************************/
extern int Enc_State;                                       /* Encoder state. */
/******************************************************************************/
/*                       MAP TO CONSTELLATION VARIABLES.
*******************************************************************************/
extern double Bit_Map[CONSTELL_SIZE];                /* Map to constellation. */
/******************************************************************************/
/*                            TRANSMITTED SYMBOLS.
*******************************************************************************/
extern double Sym0[FRAME_SIZE];                               /* Data symbol. */
extern double Sym1[FRAME_SIZE];                             /* Parity symbol. */
extern double Sym2[FRAME_SIZE];                             /* Parity symbol. */
extern double Iv_Sym0[FRAME_SIZE];                /* Interleaved data symbol. */
/******************************************************************************/
/*                    VARIABLES RELATED TO INTERLEAVER.
*******************************************************************************/
extern int Iv_Map[IV_SIZE];                           /* Interleaver mapping. */
extern int De_Iv_Map[IV_SIZE];                      /* Deinterleaver mapping. */
extern int Ck_Iv_Inx[IV_SIZE];        /* A check vector for "Iv_Noise_Val[]". */
extern double Iv_Noise_Val[IV_SIZE];   /* Stores uniformly distributed noise. */
extern unsigned short Iv_Noise_Store[PN_SIZE];          /* Stores PNS status. */
/******************************************************************************/
/*                       NOISE GENERATOR VARIABLES.
*******************************************************************************/
extern unsigned short N1_Store[PN_SIZE];                /* Stores PNS status. */
extern unsigned short N2_Store[PN_SIZE];                /* Stores PNS status. */
extern unsigned short N3_Store[PN_SIZE];                /* Stores PNS status. */
extern unsigned short N4_Store[PN_SIZE];                /* Stores PNS status. */
extern double Inv_Twice_Noise_Var;    /* Inverse of twice the noise variance. */
extern double N1_Val[NVALSIZE];                  /* Contains U & G rand. var. */
extern double N2_Val[NVALSIZE];                  /* Contains U & G rand. var. */
/******************************************************************************/
/*                    VARIABLES RELATED TO THE TRELLIS.
*******************************************************************************/
extern int Enc_N[ENC_SIZE];                    /* Stores encoder numer. taps. */
extern int Enc_D[ENC_SIZE];                    /* Stores encoder denom. taps. */
extern int Trel_NS[NUM_STATES][NUM_INPUTS];                    /* Next state. */
extern int Trel_PS[NUM_STATES][NUM_INPUTS];                    /* Prev state. */
extern int Trel_Op[NUM_STATES][NUM_INPUTS];                       /* Outputs. */
/******************************************************************************/
/*                            BCJR VARIABLES.
*******************************************************************************/
extern int Iter;                                        /* Counts iterations. */
extern double Dv_Le[FRAME_SIZE];               /* Dv. ratio of probabilities. */
extern double Iv_Le[FRAME_SIZE];               /* Dv. ratio of probabilities. */
extern double Alpha[FRAME_SIZE][NUM_STATES];                       /* Alphas. */
extern double Beta[FRAME_SIZE][NUM_STATES];                         /* Betas. */
extern double Gamma_Dv_I[FRAME_SIZE][NUM_INPUTS];      /* Dv. intrinsic info. */
extern double Gamma_Iv_I[FRAME_SIZE][NUM_INPUTS];      /* Iv. intrinsic info. */
extern double Gamma_E_P1[FRAME_SIZE][NUM_INPUTS];      /* Extrinsic info: P1. */
extern double Gamma_E_P2[FRAME_SIZE][NUM_INPUTS];      /* Extrinsic info: P2. */
extern double App_P1[FRAME_SIZE];                              /* APP for +1. */
extern double App_M1[FRAME_SIZE];                              /* APP for -1. */
/******************************************************************************/
