/******************************************************************************/
/*                          COUNTER VARIABLES.
*******************************************************************************/
int Bits[FRAME_SIZE];                               /* No. of bits per frame. */
int Iv_Bits[FRAME_SIZE];                /* No. of interleaved bits per frame. */
int Frame_Cnt;                                                /* Frame count. */
int Bit_Cnt;                                                    /* Bit count. */
int Ber;                                                   /* Bit error rate. */
/******************************************************************************/
/*                             ENCODER VARIABLES.
*******************************************************************************/
int Enc_State;                                              /* Encoder state. */
/******************************************************************************/
/*                       MAP TO CONSTELLATION VARIABLES.
*******************************************************************************/
double Bit_Map[CONSTELL_SIZE];                       /* Map to constellation. */
/******************************************************************************/
/*                            TRANSMITTED SYMBOLS.
*******************************************************************************/
double Sym0[FRAME_SIZE];                                      /* Data symbol. */
double Sym1[FRAME_SIZE];                                    /* Parity symbol. */
double Sym2[FRAME_SIZE];                                    /* Parity symbol. */
double Iv_Sym0[FRAME_SIZE];                       /* Interleaved data symbol. */
/******************************************************************************/
/*                    VARIABLES RELATED TO INTERLEAVER.
*******************************************************************************/
int Iv_Map[IV_SIZE];                                  /* Interleaver mapping. */
int De_Iv_Map[IV_SIZE];                             /* Deinterleaver mapping. */
int Ck_Iv_Inx[IV_SIZE];               /* A check vector for "Iv_Noise_Val[]". */
double Iv_Noise_Val[IV_SIZE];          /* Stores uniformly distributed noise. */
unsigned short Iv_Noise_Store[PN_SIZE];                 /* Stores PNS status. */
/******************************************************************************/
/*                       NOISE GENERATOR VARIABLES.
*******************************************************************************/
unsigned short N1_Store[PN_SIZE];                       /* Stores PNS status. */
unsigned short N2_Store[PN_SIZE];                       /* Stores PNS status. */
unsigned short N3_Store[PN_SIZE];                       /* Stores PNS status. */
unsigned short N4_Store[PN_SIZE];                       /* Stores PNS status. */
double Inv_Twice_Noise_Var;           /* Inverse of twice the noise variance. */
double N1_Val[NVALSIZE];                         /* Contains U & G rand. var. */
double N2_Val[NVALSIZE];                         /* Contains U & G rand. var. */
/******************************************************************************/
/*                    VARIABLES RELATED TO THE TRELLIS.
*******************************************************************************/
int Enc_N[ENC_SIZE];                           /* Stores encoder numer. taps. */
int Enc_D[ENC_SIZE];                           /* Stores encoder denom. taps. */
int Trel_NS[NUM_STATES][NUM_INPUTS];                           /* Next state. */
int Trel_PS[NUM_STATES][NUM_INPUTS];                           /* Prev state. */
int Trel_Op[NUM_STATES][NUM_INPUTS];                              /* Outputs. */
/******************************************************************************/
/*                            BCJR VARIABLES.
*******************************************************************************/
int Iter;                                               /* Counts iterations. */
double Dv_Le[FRAME_SIZE];                      /* Dv. ratio of probabilities. */
double Iv_Le[FRAME_SIZE];                      /* Dv. ratio of probabilities. */
double Alpha[FRAME_SIZE][NUM_STATES];                              /* Alphas. */
double Beta[FRAME_SIZE][NUM_STATES];                                /* Betas. */
double Gamma_Dv_I[FRAME_SIZE][NUM_INPUTS];             /* Dv. intrinsic info. */
double Gamma_Iv_I[FRAME_SIZE][NUM_INPUTS];             /* Iv. intrinsic info. */
double Gamma_E_P1[FRAME_SIZE][NUM_INPUTS];             /* Extrinsic info: P1. */
double Gamma_E_P2[FRAME_SIZE][NUM_INPUTS];             /* Extrinsic info: P2. */
double App_P1[FRAME_SIZE];                                     /* APP for +1. */
double App_M1[FRAME_SIZE];                                     /* APP for -1. */
/******************************************************************************/
