/******************************************************************************/
#include "tc2type.h"
#include "tc2ext.h"
/******************************************************************************/
int Get_Iv_Map()
{
 Get_Uniform_Noise();
 Get_Iv_Elements();
 Print_Iv_Map();
 return(0);
}
/******************************************************************************/
/*                   Get uniformly distributed noise.
*******************************************************************************/
int Get_Uniform_Noise()
{
 int cnt;
 double erand48();
 for(cnt=ZERO;cnt<IV_SIZE;cnt++)
  Iv_Noise_Val[cnt]=(double)erand48(Iv_Noise_Store);
 return(0);
}
/******************************************************************************/
/*                        Get the interleaver map.
*******************************************************************************/
int Get_Iv_Elements()
{
 int cnt,max_inx,iv_inx;
 double max;
 for(iv_inx=ZERO;iv_inx<IV_SIZE;iv_inx++)
 {
  max=MIN_MAG;
  for(cnt=ZERO;cnt<IV_SIZE;cnt++)
  {
   if((Ck_Iv_Inx[cnt] == ZERO) && (Iv_Noise_Val[cnt] > max))
   {
    max=Iv_Noise_Val[cnt];
    max_inx=cnt;
   }
  }
  Ck_Iv_Inx[max_inx]=ONE;                    /* Dont check max_inx next time. */
  Iv_Map[iv_inx]=max_inx;                                 /* Interleaver map. */
  De_Iv_Map[max_inx]=iv_inx;                            /* Deinterleaver map. */
 }
 return(0);
}
/******************************************************************************/
/*                       Print the interleaver map.
*******************************************************************************/
int Print_Iv_Map()
{
 int cnt;
 printf("\t Interleaver map.\n\n");
 for(cnt=ZERO;cnt<IV_SIZE;cnt++)
 {
  printf("\t\t Iv. map Index:%5d Map:%5d\n",cnt,Iv_Map[cnt]);
  printf("\t\t Dv. map Index:%5d Map:%5d\n",cnt,De_Iv_Map[cnt]);
 }
 printf("\n");
 fflush(stdout);
 return(0);
}
/******************************************************************************/
