/******************************************************************************/
#include "tc2ctype.h"
#include "tc2cext.h"
/******************************************************************************/
/*                   Initialize simulation variables.
*******************************************************************************/
int Sim_Init()
{
 Noise_Gen_Init();
 Iv_Noise_Gen_Init();
 Coloured_Noise_Filter_Init();
 Ber_Init();
 return(0);
}
/******************************************************************************/
/*                     Initialize the noise generator.
*******************************************************************************/
int Noise_Gen_Init()
{
 int cnt;
 long int random(void);
 for(cnt=ZERO;cnt<PN_SIZE;cnt++)
 {
  N1_Store[cnt]=(unsigned short)random();
  N2_Store[cnt]=(unsigned short)random();
  N3_Store[cnt]=(unsigned short)random();
  N4_Store[cnt]=(unsigned short)random();
 }
 Inv_Twice_Noise_Var=1.0/(2.0*VARIANCE);
 return(0);
}
/******************************************************************************/
/*                Initialize the interleaver noise generator.
*******************************************************************************/
int Iv_Noise_Gen_Init()
{
 Iv_Noise_Store[0]=15131;
 Iv_Noise_Store[1]=13111;
 Iv_Noise_Store[2]=10591;
 return(0);
}
/******************************************************************************/
/*          Initialize the filters that generate coloured noise.
*******************************************************************************/
int Coloured_Noise_Filter_Init()
{
 if(FILTER == 1)
  Filter1_Init();
 else if(FILTER == 2)
  Filter2_Init();
 return(0);
}
/******************************************************************************/
/*                        Initialize the first filter.
*******************************************************************************/
int Filter1_Init()
{
 double tmp;
 tmp=0.9;
 Ip_Coeff=sqrt(1.0-tmp*tmp);
 Coeff_Array[0]= -tmp;
 return(0);
}
/******************************************************************************/
/*                        Initialize the second filter.
*******************************************************************************/
int Filter2_Init()
{
 int cnt;
 Filter_Array[0]=1.0/sqrt(91.0);
 Filter_Array[1]=2.0/sqrt(91.0);
 Filter_Array[2]=3.0/sqrt(91.0);
 Filter_Array[3]=4.0/sqrt(91.0);
 Filter_Array[4]=5.0/sqrt(91.0);
 Filter_Array[5]=6.0/sqrt(91.0);
 for(cnt=ZERO;cnt<FILTER_SIZE;cnt++)
  printf("\t Type 2 filter coeff:%d is :%lf\n",cnt,Filter_Array[cnt]);
 printf("\n");
 return(0);
}
/******************************************************************************/
/*                       Initialize the bit error rate.
*******************************************************************************/
int Ber_Init()
{
 Ber=ZERO;
 return(0);
}
/******************************************************************************/
