/******************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
/******************************************************************************/
/*                    SIMULATION RUN LENGTH PARAMETER.
*******************************************************************************/
#define MAX_FRAMES 10001                         /* Length of simulation run. */
#define FRAME_SIZE 1000                      /* No. of input bits in a frame. */
#define IV_SIZE FRAME_SIZE                        /* Size of the interleaver. */
/******************************************************************************/
/*                         CONSTELLATION PARAMETERS.
*******************************************************************************/
#define BITS_PER_SYM 1                                /* Bits per tx. symbol. */
#define CONSTELL_SIZE 2                      /* Size of output constellation. */
/******************************************************************************/
/*                          TRELLIS PARAMETERS.
*******************************************************************************/
#define MEM_SIZE 4                                      /* Memory of encoder. */
#define ENC_SIZE (MEM_SIZE+1)                /* Max. no. of taps for encoder. */
#define NUM_STATES 16              /* No. of states in the component trellis. */
#define NUM_INPUTS 2                          /* No. of inputs to each state. */
#define PRED_MEM_SIZE 1                          /* Size of predictor memory. */
/******************************************************************************/
/*                  GAUSSIAN NOISE GENERATOR PARAMETERS.
*******************************************************************************/
#define VARIANCE 1.500                                     /* Noise variance. */
#define PN_SIZE 3                 /* Size of array which stores the PN value. */
#define NVALSIZE 4
#define URADIUS 0
#define UTHETA 1
#define GRAND_0 2
#define GRAND_1 3
#define WHITE 1                            /* 1:White noise;0:coloured noise. */
#define FILTER 2                                              /* Filter type. */
#define FILTER_SIZE 6           /* Length of filter to obtain coloured noise. */
/******************************************************************************/
/*                             BCJR PARAMETERS.
*******************************************************************************/
#define MAX_ITER 4
/******************************************************************************/
/*                                PRINT TIME.
*******************************************************************************/
#define PRINT_TIME 1
/******************************************************************************/
/*                             CONSTANTS.
*******************************************************************************/
#define BINSIZE 16         /* Size of array to store states in binary format. */
#define TWO 2
#define ONE 1
#define ZERO 0
#define TRUE 1
#define FALSE 0
#define LEFT 0
#define RIGHT 1
#define RE 0
#define IM 1
#define MINUSONE (-1)
#define ERROR 0.000001
#define FRAC_ZERO 0.0
#define MIN_MAG (-10.0)
#define MY_PI 3.14159265358979323846
#define PIBY2 1.57079632679489661923
#define PIBY4 0.785398163397448309615
#define TWICEPI 6.28318530717958647692
/******************************************************************************/
