/******************************************************************************/
#include "tc3type.h"
#include "tc3ext.h"
/******************************************************************************/
/*             Compute the final APP ratios in the last iteration.
*******************************************************************************/
int Compute_APPs_Dec1()
{
 int time;
 for(time=ZERO;time<FRAME_SIZE;time++)
 {
  Get_APP_Due_to_P1_Dec1(time);
  Get_APP_Due_to_M1_Dec1(time);
 }
 return(0);
}
/******************************************************************************/
/*                 Get a posteriori probability due to +1.
*******************************************************************************/
int Get_APP_Due_to_P1_Dec1(time)
int time;
{
 int state,nxt_state,op;
 double ge,gi,prob,nxt_beta,prv_alpha;
 App_P1[time]=0.0;
 for(state=ZERO;state<NUM_STATES;state++)
 {
  nxt_state=Trel_NS[state][ZERO];                            /* 0 maps to +1. */
  op=Trel_Op[state][ZERO];
  ge=Gamma_E[time][op];                             /* Corresponds to parity. */
  gi=Gamma_I[time][ZERO];                             /* Corresponds to data. */
  prob=Le[time]/(1.0+Le[time]);
  prv_alpha=nxt_beta=1.0;
  if(time > ZERO)
   prv_alpha=Alpha[time-ONE][state];
  if(time < (FRAME_SIZE-ONE))
   nxt_beta=Beta[time+ONE][nxt_state];
  App_P1[time]=App_P1[time]+ge*gi*prob*prv_alpha*nxt_beta;
 }
 return(0);
}
/******************************************************************************/
/*                 Get a posteriori probability due to -1.
*******************************************************************************/
int Get_APP_Due_to_M1_Dec1(time)
int time;
{
 int state,nxt_state,op;
 double ge,gi,prob,nxt_beta,prv_alpha;
 App_M1[time]=0.0;
 for(state=ZERO;state<NUM_STATES;state++)
 {
  nxt_state=Trel_NS[state][ONE];                             /* 1 maps to -1. */
  op=Trel_Op[state][ONE];
  ge=Gamma_E[time][op];                             /* Corresponds to parity. */
  gi=Gamma_I[time][ONE];                              /* Corresponds to data. */
  prob=1.0/(1.0+Le[time]);
  prv_alpha=nxt_beta=1.0;
  if(time > ZERO)
   prv_alpha=Alpha[time-ONE][state];
  if(time < (FRAME_SIZE-ONE))
   nxt_beta=Beta[time+ONE][nxt_state];
  App_M1[time]=App_M1[time]+ge*gi*prob*prv_alpha*nxt_beta;
 }
 return(0);
}
/******************************************************************************/
