/******************************************************************************/
/*                          COUNTER VARIABLES.
*******************************************************************************/
extern int Bits[FRAME_SIZE];                        /* No. of bits per frame. */
extern int Frame_Cnt;                                         /* Frame count. */
extern int Bit_Cnt;                                             /* Bit count. */
extern int Ber;                                            /* Bit error rate. */
/******************************************************************************/
/*                             ENCODER VARIABLES.
*******************************************************************************/
extern int Enc_State;                                       /* Encoder state. */
extern int Enc1_State_T0;                /* Stores encoder 1 state at time 0. */
extern int Enc2_State_T0;                /* Stores encoder 2 state at time 0. */
/******************************************************************************/
/*                       MAP TO CONSTELLATION VARIABLES.
*******************************************************************************/
extern double Bit_Map[CONSTELL_SIZE];                /* Map to constellation. */
/******************************************************************************/
/*                            TRANSMITTED SYMBOLS.
*******************************************************************************/
extern double Re_Sym0[FRAME_SIZE];                 /* Re. sym. at enc. 0 o/p. */
extern double Im_Sym0[FRAME_SIZE];                 /* Im. sym. at enc. 0 o/p. */
extern double Re_Sym1[FRAME_SIZE];                 /* Re. sym. at enc. 1 o/p. */
extern double Im_Sym1[FRAME_SIZE];                 /* Im. sym. at enc. 1 o/p. */
/******************************************************************************/
/*                    VARIABLES RELATED TO INTERLEAVER.
*******************************************************************************/
extern int Iv_Map[IV_SIZE];                           /* Interleaver mapping. */
extern int De_Iv_Map[IV_SIZE];                      /* Deinterleaver mapping. */
extern unsigned short Iv_Noise_Store[PN_SIZE];          /* Stores PNS status. */
/******************************************************************************/
/*                       NOISE GENERATOR VARIABLES.
*******************************************************************************/
extern unsigned short N1_Store[PN_SIZE];                /* Stores PNS status. */
extern unsigned short N2_Store[PN_SIZE];                /* Stores PNS status. */
extern unsigned short N3_Store[PN_SIZE];                /* Stores PNS status. */
extern unsigned short N4_Store[PN_SIZE];                /* Stores PNS status. */
extern double Pred_Var;                   /* Final prediction error variance. */
extern double Inv_Twice_Pred_Var;        /* Inv. of twice the pred. err. var. */
extern double Re_Noise_0;                         /* Re. noise at enc. 0 o/p. */
extern double Im_Noise_0;                         /* Im. noise at enc. 0 o/p. */
extern double Re_Noise_1;                         /* Re. noise at enc. 1 o/p. */
extern double Im_Noise_1;                         /* Im. noise at enc. 1 o/p. */
extern double N1_Val[NVALSIZE];                  /* Contains U & G rand. var. */
extern double N2_Val[NVALSIZE];                  /* Contains U & G rand. var. */
extern double Re_Pred_Coeff[NUM_PRED][PRED_SIZE];         /* Re. pred. coeff. */
extern double Im_Pred_Coeff[NUM_PRED][PRED_SIZE];         /* Im. pred. coeff. */
extern double Re_Flt[FILTER_SIZE];                /* Re. filter coefficients. */
extern double Im_Flt[FILTER_SIZE];                /* Im. filter coefficients. */
extern double Re_F0_Reg[FILTER_SIZE];                    /* Re. filter 0 reg. */
extern double Im_F0_Reg[FILTER_SIZE];                    /* Im. filter 0 reg. */
extern double Re_F1_Reg[FILTER_SIZE];                    /* Re. filter 1 reg. */
extern double Im_F1_Reg[FILTER_SIZE];                    /* Im. filter 1 reg. */
extern double Re_AC[PRED_MEM_SIZE+ONE];       /* Re. autocorr. of the filter. */
extern double Im_AC[PRED_MEM_SIZE+ONE];       /* Im. autocorr. of the filter. */
/******************************************************************************/
/*                    VARIABLES RELATED TO THE TRELLIS.
*******************************************************************************/
extern int Inx_To_VG_Tbl;               /* No. of entries in valid gamma tbl. */
extern int Valid_Gamma_Inx[VG_TBL_SIZE];    /* Tbl. with valid gamma indices. */
extern int Enc_N[ENC_SIZE];                    /* Stores encoder numer. taps. */
extern int Enc_D[ENC_SIZE];                    /* Stores encoder denom. taps. */
extern int Trel_NS[NUM_STATES][NUM_INPUTS];                    /* Next state. */
extern int Trel_PS[NUM_STATES][NUM_INPUTS];                    /* Prev state. */
extern int Trel_Op[NUM_STATES][NUM_INPUTS];                       /* Outputs. */
extern int STrel_NS[NUM_ST_STATES][NUM_INPUTS];   /* Super trellis nxt state. */
extern int STrel_PS[NUM_ST_STATES][NUM_INPUTS];   /* Super trellis prv state. */
extern int STrel_Op[NUM_ST_STATES][NUM_INPUTS];     /* Super trellis outputs. */
extern int STrel_Ip[NUM_ST_STATES][NUM_INPUTS];  /* Inputs leading to states. */
extern int STrel_Inx[NUM_ST_STATES][NUM_INPUTS];               /* Prv inputs. */
/******************************************************************************/
/*                            BCJR VARIABLES.
*******************************************************************************/
extern int Iter;                                        /* Counts iterations. */
extern double Alpha[FRAME_SIZE][NUM_ST_STATES];                    /* Alphas. */
extern double Beta[FRAME_SIZE][NUM_ST_STATES];                      /* Betas. */
extern double *Gamma_Dec1[FRAME_SIZE];                /* Gamma for decoder 1. */
extern double *Gamma_Dec2[FRAME_SIZE];                /* Gamma for decoder 2. */
extern double Prob[FRAME_SIZE][NUM_INPUTS];            /* Data probabilities. */
/******************************************************************************/
