/******************************************************************************/
/*                          COUNTER VARIABLES.
*******************************************************************************/
int Bits[FRAME_SIZE];                               /* No. of bits per frame. */
int Frame_Cnt;                                                /* Frame count. */
int Bit_Cnt;                                                    /* Bit count. */
int Ber;                                                   /* Bit error rate. */
/******************************************************************************/
/*                             ENCODER VARIABLES.
*******************************************************************************/
int Enc_State;                                              /* Encoder state. */
/******************************************************************************/
/*                       MAP TO CONSTELLATION VARIABLES.
*******************************************************************************/
double Bit_Map[CONSTELL_SIZE];                       /* Map to constellation. */
/******************************************************************************/
/*                            TRANSMITTED SYMBOLS.
*******************************************************************************/
double Re_Sym0[FRAME_SIZE];                        /* Re. sym. at enc. 0 o/p. */
double Im_Sym0[FRAME_SIZE];                        /* Im. sym. at enc. 0 o/p. */
double Re_Sym1[FRAME_SIZE];                        /* Re. sym. at enc. 1 o/p. */
double Im_Sym1[FRAME_SIZE];                        /* Im. sym. at enc. 1 o/p. */
/******************************************************************************/
/*                    VARIABLES RELATED TO INTERLEAVER.
*******************************************************************************/
int Iv_Map[IV_SIZE];                                  /* Interleaver mapping. */
int De_Iv_Map[IV_SIZE];                             /* Deinterleaver mapping. */
unsigned short Iv_Noise_Store[PN_SIZE];                 /* Stores PNS status. */
/******************************************************************************/
/*                       NOISE GENERATOR VARIABLES.
*******************************************************************************/
unsigned short N1_Store[PN_SIZE];                       /* Stores PNS status. */
unsigned short N2_Store[PN_SIZE];                       /* Stores PNS status. */
unsigned short N3_Store[PN_SIZE];                       /* Stores PNS status. */
unsigned short N4_Store[PN_SIZE];                       /* Stores PNS status. */
double Inv_Twice_Var;                         /* Inv. of twice the noise var. */
double Re_Noise_0;                                /* Re. noise at enc. 0 o/p. */
double Im_Noise_0;                                /* Im. noise at enc. 0 o/p. */
double Re_Noise_1;                                /* Re. noise at enc. 1 o/p. */
double Im_Noise_1;                                /* Im. noise at enc. 1 o/p. */
double N1_Val[NVALSIZE];                         /* Contains U & G rand. var. */
double N2_Val[NVALSIZE];                         /* Contains U & G rand. var. */
double Re_Flt[FILTER_SIZE];                       /* Re. filter coefficients. */
double Im_Flt[FILTER_SIZE];                       /* Im. filter coefficients. */
double Re_F0_Reg[FILTER_SIZE];                           /* Re. filter 0 reg. */
double Im_F0_Reg[FILTER_SIZE];                           /* Im. filter 0 reg. */
double Re_F1_Reg[FILTER_SIZE];                           /* Re. filter 1 reg. */
double Im_F1_Reg[FILTER_SIZE];                           /* Im. filter 1 reg. */
/******************************************************************************/
/*                    VARIABLES RELATED TO THE TRELLIS.
*******************************************************************************/
int Enc_N[ENC_SIZE];                           /* Stores encoder numer. taps. */
int Enc_D[ENC_SIZE];                           /* Stores encoder denom. taps. */
int Trel_NS[NUM_STATES][NUM_INPUTS];                           /* Next state. */
int Trel_PS[NUM_STATES][NUM_INPUTS];                           /* Prev state. */
int Trel_Op[NUM_STATES][NUM_INPUTS];                              /* Outputs. */
/******************************************************************************/
/*                            BCJR VARIABLES.
*******************************************************************************/
int Iter;                                               /* Counts iterations. */
double Alpha[FRAME_SIZE][NUM_STATES];                              /* Alphas. */
double Beta[FRAME_SIZE][NUM_STATES];                                /* Betas. */
double Gamma_Dec1[FRAME_SIZE][NUM_GAMMA_INX];         /* Gamma for decoder 1. */
double Gamma_Dec2[FRAME_SIZE][NUM_GAMMA_INX];         /* Gamma for decoder 2. */
double Prob[FRAME_SIZE][NUM_INPUTS];                   /* Data probabilities. */
/******************************************************************************/
