/******************************************************************************/
#include "tc6ctype.h"
#include "tc6cext.h"
/******************************************************************************/
/*                   Initialize simulation variables.
*******************************************************************************/
int Sim_Init()
{
 Noise_Gen_Init();
 Iv_Noise_Gen_Init();
 Ber_Init();
 Eq_Init();
 Err_Reg_Init();
 Chan_Init();
 return(0);
}
/******************************************************************************/
/*                     Initialize the noise generator.
*******************************************************************************/
int Noise_Gen_Init()
{
 int cnt;
 long int random(void);
 for(cnt=ZERO;cnt<PN_SIZE;cnt++)
 {
  N1_Store[cnt]=(unsigned short)random();
  N2_Store[cnt]=(unsigned short)random();
 }
 return(0);
}
/******************************************************************************/
/*                Initialize the interleaver noise generator.
*******************************************************************************/
int Iv_Noise_Gen_Init()
{
 Iv_Noise_Store[0]=15131;
 Iv_Noise_Store[1]=13111;
 Iv_Noise_Store[2]=10591;
 return(0);
}
/******************************************************************************/
/*                       Initialize the bit error rate.
*******************************************************************************/
int Ber_Init()
{
 Ber=ZERO;
 return(0);
}
/******************************************************************************/
/*                    Initialize equalizer parameters.
*******************************************************************************/
int Eq_Init()
{
 int cnt;
 for(cnt=ZERO;cnt<EQ_SIZE;cnt++)
  Re_Eq[cnt]=Im_Eq[cnt]=Re_Eq_Reg[cnt]=Im_Eq_Reg[cnt]=0.0;
 Step=0.5;
 return(0);
}
/******************************************************************************/
/*                      Initialize the error register.
*******************************************************************************/
int Err_Reg_Init()
{
 int cnt;
 Err_Reg_Inx=0.0;
 return(0);
}
/******************************************************************************/
/*                          Initialize the channel.
*******************************************************************************/
int Chan_Init()
{
 int cnt;
 for(cnt=ZERO;cnt<CHAN_SIZE;cnt++)
  Re_Ch_Reg[cnt]=Im_Ch_Reg[cnt]=0.0;
 return(0);
}
/******************************************************************************/
