/******************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
/******************************************************************************/
/*                    SIMULATION RUN LENGTH PARAMETER.
*******************************************************************************/
#define TRN_FRAMES 10                          /* No. of frames for training. */
#define MAX_FRAMES (TRN_FRAMES+10000)            /* Length of simulation run. */
#define FRAME_SIZE 1000                      /* No. of input bits in a frame. */
#define IV_SIZE FRAME_SIZE                        /* Size of the interleaver. */
/******************************************************************************/
/*                         CONSTELLATION PARAMETERS.
*******************************************************************************/
#define IP_BITS_PER_SYM 1                           /* Input bits per symbol. */
#define IP_CONSTELL_SIZE 2                    /* Size of input constellation. */
#define BITS_PER_SYM 2                                /* Bits per tx. symbol. */
#define CONSTELL_SIZE 4                      /* Size of output constellation. */
/******************************************************************************/
/*                            TRELLIS PARAMETERS.
*******************************************************************************/
#define MEM_SIZE 4                                      /* Memory of encoder. */
#define ENC_SIZE (MEM_SIZE+1)                /* Max. no. of taps for encoder. */
#define NUM_STATES 16              /* No. of states in the component trellis. */
#define NUM_INPUTS 2                          /* No. of inputs to each state. */
#define NUM_GAMMA_INX 4                              /* No. of gamma indices. */
/******************************************************************************/
/*                           CHANNEL PARAMETERS.
*******************************************************************************/
#define CHAN_SIZE 6                                 /* Length of the channel. */
/******************************************************************************/
/*                           EQUALIZER PARAMETERS.
*******************************************************************************/
#define EQ_SIZE 41                                /* Length of the equalizer. */
#define SYS_DELAY 20                                     /* Start of eq. trn. */
/******************************************************************************/
/*                       EQUALIZER ERROR PARAMETERS.
*******************************************************************************/
#define DATA_SIZE 400         /* Size of data for estimating predictor coeff. */
#define COLLECT_START 1000                  /* Time to start collecting data. */
#define COLLECT_END (COLLECT_START+TWO*DATA_SIZE)    /* Stop collecting data. */
/******************************************************************************/
/*                  GAUSSIAN NOISE GENERATOR PARAMETERS.
*******************************************************************************/
#define SNR  10.90                                     /* Noise variance. */
#define MAX_SNR 100.0           /* Max. value of SNR for zero noise variance. */
#define PN_SIZE 3                 /* Size of array which stores the PN value. */
#define NVALSIZE 4
#define URADIUS 0
#define UTHETA 1
#define GRAND_0 2
#define GRAND_1 3
#define WHITE 0                            /* 1:White noise;0:coloured noise. */
/******************************************************************************/
/*                             BCJR PARAMETERS.
*******************************************************************************/
#define MAX_ITER 4
/******************************************************************************/
/*                                PRINT TIME.
*******************************************************************************/
#define PRINT_TIME 416
/******************************************************************************/
/*                             CONSTANTS.
*******************************************************************************/
#define BINSIZE 16         /* Size of array to store states in binary format. */
#define TWO 2
#define ONE 1
#define ZERO 0
#define TRUE 1
#define FALSE 0
#define LEFT 0
#define RIGHT 1
#define RE 0
#define IM 1
#define MINUSONE (-1)
#define ERROR 0.000001
#define FRAC_ZERO 0.0
#define MIN_MAG (-10.0)
#define MY_PI 3.14159265358979323846
#define PIBY2 1.57079632679489661923
#define PIBY4 0.785398163397448309615
#define TWICEPI 6.28318530717958647692
/******************************************************************************/
