/******************************************************************************/
/*                  Plot the histogram for an array of data.
*******************************************************************************/
#include <stdio.h>
#include <math.h>
/******************************************************************************/
#define MAX_DATA 100000                         /* Max. no. of input samples. */
#define NUM_BINS 100                                     /* No. of data bins. */
#define ZERO 0                                               /* Integer zero. */
#define MIN_DATA_VAL 0.0                      /* Min. value of data expected. */
#define MAX_DATA_VAL 1.100                    /* Max. value of data expected. */
/******************************************************************************/
FILE *fp1,*fp2;                                             /* File pointers. */
int Num_Data;                                 /* Actual no. of input samples. */
int Hist[NUM_BINS];                                /* Contains the histogram. */
double Data[MAX_DATA];                            /* Array to store the data. */
/******************************************************************************/
main()
{
 Open_Files();
 Read_File();
 Initialize_Histogram();
 Get_Histogram();
 Print_Histogram();
}
/******************************************************************************/
/*                             Get the inputs.
*******************************************************************************/
int Open_Files()
{
 fp1=fopen("prob0.dat","r");
 if(fp1 == NULL)
  Error_Mes(1);
 fp2=fopen("prob0hist.dat","w");
 return(0);
}
/******************************************************************************/
/*                          Read the input data.
*******************************************************************************/
int Read_File()
{
 double tmp;
 Num_Data=ZERO;
 while(fscanf(fp1,"%lf",&tmp) != EOF)
 {
  if(Num_Data == MAX_DATA)
   Error_Mes(2);
  if((tmp < MIN_DATA_VAL) || (tmp >= MAX_DATA_VAL))
   Error_Mes(3);
  Data[Num_Data]=tmp;
  Num_Data++;
 }
 return(0);
}
/******************************************************************************/
/*                         Initialize the histogram.
*******************************************************************************/
int Initialize_Histogram()
{
 int cnt;
 for(cnt=ZERO;cnt<NUM_BINS;cnt++)
  Hist[cnt]=ZERO;
 return(0);
}
/******************************************************************************/
/*                           Get the histogram.
*******************************************************************************/
int Get_Histogram()
{
 int cnt,bin;
 double bin_size;
 bin_size=(MAX_DATA_VAL-MIN_DATA_VAL)/NUM_BINS;
 for(cnt=ZERO;cnt<Num_Data;cnt++)
 {
  bin=(Data[cnt]-MIN_DATA_VAL)/bin_size;
  if(bin >= NUM_BINS)
   Error_Mes(4);
  Hist[bin]++;
 }
 return(0);
}
/******************************************************************************/
/*                       Print the histogram to a file.
*******************************************************************************/
int Print_Histogram()
{
 int cnt;
 double bin_size;
 bin_size=(MAX_DATA_VAL-MIN_DATA_VAL)/NUM_BINS;
 for(cnt=ZERO;cnt<NUM_BINS;cnt++)
  fprintf(fp2,"%lf %lf\n",(double)cnt*bin_size,(double)Hist[cnt]);
 return(0);
}
/******************************************************************************/
/*                           Print error messages.
*******************************************************************************/
int Error_Mes(num)
{
 fprintf(stderr,"Simulation error. Exiting with code %d.\n",num);
 fflush(stderr);
 exit(num);
 return(0);
}
/******************************************************************************/
