/******************************************************************************/
/*                          FILE POINTER VARIABLES.
*******************************************************************************/
FILE *fp1,*fp2;                                             /* File pointers. */
/******************************************************************************/
/*                                BIT VARIABLES.
*******************************************************************************/
int Bits[FRAME_SIZE];                                    /* Information bits. */
int Parity1[FRAME_SIZE];                                    /* Parity 1 bits. */
int Parity2[FRAME_SIZE];                                    /* Parity 2 bits. */
int P1_Error;                                   /* No. of errors in parity 1. */
int P2_Error;                                   /* No. of errors in parity 1. */
int Frame_Cnt;                                                /* Frame count. */
int Bit_Cnt;                                                    /* Bit count. */
int Ber;                                                   /* Bit error rate. */
int Fer;                                                 /* Frame error rate. */
int Frame_Err_Cnt;                                      /* Frame error count. */
/******************************************************************************/
/*                             ENCODER VARIABLES.
*******************************************************************************/
int Enc_State;                                              /* Encoder state. */
/******************************************************************************/
/*                       MAP TO CONSTELLATION VARIABLES.
*******************************************************************************/
double Bit_Map[CONSTELL_SIZE];                       /* Map to constellation. */
/******************************************************************************/
/*                            TRANSMITTED SYMBOLS.
*******************************************************************************/
double Sym0[FRAME_SIZE];                                      /* Data symbol. */
double Sym1[FRAME_SIZE];                                    /* Parity symbol. */
double Sym2[FRAME_SIZE];                                    /* Parity symbol. */
/******************************************************************************/
/*                    VARIABLES RELATED TO INTERLEAVER.
*******************************************************************************/
int Iv_Map[IV_SIZE];                                  /* Interleaver mapping. */
int De_Iv_Map[IV_SIZE];                             /* Deinterleaver mapping. */
unsigned short Iv_Noise_Store[PN_SIZE];                 /* Stores PNS status. */
/******************************************************************************/
/*                       NOISE GENERATOR VARIABLES.
*******************************************************************************/
unsigned short N1_Store[PN_SIZE];                       /* Stores PNS status. */
unsigned short N2_Store[PN_SIZE];                       /* Stores PNS status. */
unsigned short N3_Store[PN_SIZE];                       /* Stores PNS status. */
unsigned short N4_Store[PN_SIZE];                       /* Stores PNS status. */
unsigned short N5_Store[PN_SIZE];                       /* Stores PNS status. */
unsigned short N6_Store[PN_SIZE];                       /* Stores PNS status. */
double Inv_Twice_Noise_Var;           /* Inverse of twice the noise variance. */
double N1_Val[NVALSIZE];                         /* Contains U & G rand. var. */
double N2_Val[NVALSIZE];                         /* Contains U & G rand. var. */
double N3_Val[NVALSIZE];                         /* Contains U & G rand. var. */
/******************************************************************************/
/*                    VARIABLES RELATED TO THE TRELLIS.
*******************************************************************************/
int Enc_N[ENC_SIZE];                           /* Stores encoder numer. taps. */
int Enc_D[ENC_SIZE];                           /* Stores encoder denom. taps. */
int Trel_NS[NUM_STATES][NUM_INPUTS];                           /* Next state. */
int Trel_PS[NUM_STATES][NUM_INPUTS];                           /* Prev state. */
int Trel_Op[NUM_STATES][NUM_INPUTS];                              /* Outputs. */
/******************************************************************************/
/*                            BCJR VARIABLES.
*******************************************************************************/
int Iter;                                               /* Counts iterations. */
int P1_Bit0_Cnt;                                              /* No. of P1=0. */
int P1_Bit1_Cnt;                                              /* No. of P1=1. */
int P2_Bit0_Cnt;                                              /* No. of P2=0. */
int P2_Bit1_Cnt;                                              /* No. of P2=1. */
int P1_Bit0_Loc[FRAME_SIZE>>1];                         /* Locations of P1=0. */
int P1_Bit1_Loc[FRAME_SIZE>>1];                         /* Locations of P1=1. */
int P2_Bit0_Loc[FRAME_SIZE>>1];                         /* Locations of P2=0. */
int P2_Bit1_Loc[FRAME_SIZE>>1];                         /* Locations of P2=1. */
double Alpha[FRAME_SIZE][NUM_STATES];                              /* Alphas. */
double Beta[FRAME_SIZE][NUM_STATES];                                /* Betas. */
double Gamma_I[FRAME_SIZE][NUM_INPUTS];                /* Dv. intrinsic info. */
double Gamma_E_P1[FRAME_SIZE][NUM_INPUTS];             /* Extrinsic info: P1. */
double Gamma_E_P2[FRAME_SIZE][NUM_INPUTS];             /* Extrinsic info: P2. */
double Est_Gamma_E_P1[FRAME_SIZE][NUM_INPUTS];               /* Estimated P1. */
double Est_Gamma_E_P2[FRAME_SIZE][NUM_INPUTS];               /* Estimated P2. */
double Act_Gamma_E_P1[FRAME_SIZE][NUM_INPUTS];                  /* Actual P1. */
double Act_Gamma_E_P2[FRAME_SIZE][NUM_INPUTS];                  /* Actual P2. */
double Prob[FRAME_SIZE][NUM_INPUTS];                   /* Data probabilities. */
/******************************************************************************/
