/******************************************************************************/
#include "tc7type.h"
#include "tc7ext.h"
/******************************************************************************/
/*                       Get the interleaver elements.
*******************************************************************************/
int Get_Parity_Iv_Elements(iv_noise_val,ck_iv_inx,iv_size,piv_map)
int ck_iv_inx[],piv_map[];
double iv_noise_val[];
{
 int cnt,max_inx,iv_inx;
 double max;
 for(iv_inx=ZERO;iv_inx<iv_size;iv_inx++)
 {
  max=MIN_MAG;
  for(cnt=ZERO;cnt<iv_size;cnt++)
  {
   if((ck_iv_inx[cnt] == ZERO) && (iv_noise_val[cnt] > max))
   {
    max=iv_noise_val[cnt];
    max_inx=cnt;
   }
  }
  ck_iv_inx[max_inx]=ONE;                    /* Dont check max_inx next time. */
//  piv_map[iv_inx]=max_inx;                              /* Interleaver map. */
  piv_map[iv_inx]=iv_inx;                              /* Interleaver map. */
 }
 return(0);
}
/******************************************************************************/
/*           Print the interleaver map for a given parity and bit.
*******************************************************************************/
int Print_Parity_Iv_Map(piv_map,iv_size,parity,bit)
int piv_map[],iv_size,parity,bit;
{
 int cnt;
 printf("\t Interleaver map for parity %d bit %d.\n\n",parity,bit);
 for(cnt=ZERO;cnt<iv_size;cnt++)
  printf("\t\t Iv. map Index:%5d Map:%5d\n",cnt,piv_map[cnt]);
 printf("\n");
 fflush(stdout);
 return(0);
}
/******************************************************************************/
/*                        Interleave the elements.
*******************************************************************************/
int Interleave(est_array,array,piv_map,iv_size,bit,loc_array)
int piv_map[],iv_size,bit,loc_array[];
double est_array[FRAME_SIZE][NUM_INPUTS],array[FRAME_SIZE][NUM_INPUTS];
{
 int cnt,act_loc,piv_loc,act_piv_loc,comp_bit;
 double copy_of_array[FRAME_SIZE][NUM_INPUTS];
 comp_bit=(bit+1)%2;
 Array_Copy(array,copy_of_array);
 for(cnt=ZERO;cnt<iv_size;cnt++)
 {
  act_loc=loc_array[cnt];
  piv_loc=piv_map[cnt];
  act_piv_loc=loc_array[piv_loc];
//  printf("bit:%d gamma:%lf ",bit,array[act_loc][bit]);
  array[act_loc][bit]=copy_of_array[act_piv_loc][bit];
//  printf("ix:%d aloc:%d iloc:%d ailoc:%d ",cnt,act_loc,piv_loc,act_piv_loc);
//  printf("mod gamma:%lf\n",array[act_loc][bit]);
  array[act_loc][comp_bit]=copy_of_array[act_piv_loc][comp_bit];
 }
 return(0);
}
/******************************************************************************/
/*                      Copy one array into the other.
*******************************************************************************/
int Array_Copy(array,copy_of_array)
double array[FRAME_SIZE][NUM_INPUTS],copy_of_array[FRAME_SIZE][NUM_INPUTS];
{
 int cnt1,cnt2;
 for(cnt1=ZERO;cnt1<FRAME_SIZE;cnt1++)
 {
  for(cnt2=ZERO;cnt2<NUM_INPUTS;cnt2++)
   copy_of_array[cnt1][cnt2]=array[cnt1][cnt2];
 }
 return(0);
}
/******************************************************************************/
