/******************************************************************************/
#include "tc7type.h"
#include "tc7ext.h"
/******************************************************************************/
/*                   Get the symbol to be transmitted.
*******************************************************************************/
int Get_Frame()
{
 Get_Data_Bits();
 Get_Enc_Iv_Bits();
// Print_Input_Bits();
// Print_Symbols();
 return(0);
}
/******************************************************************************/
/*                          Get the data bits.
*******************************************************************************/
int Get_Data_Bits()
{
 int cnt,bit,enc_bit;
 int rand(void);
 Enc_State=ZERO;                                         /* State at time -1. */
 for(cnt=ZERO;cnt<FRAME_SIZE;cnt++)
 {
  bit=Bits[cnt]=rand()&1;
  enc_bit=Trel_Op[Enc_State][bit];
  Enc_State=Trel_NS[Enc_State][bit];                  /* State at time "cnt". */
  Sym0[cnt]=Bit_Map[bit];
  Sym1[cnt]=Bit_Map[enc_bit];
  Parity1[cnt]=enc_bit;
 }
// printf("\t Encoder 1 state after data bits:%d.\n\n",Enc_State);
 return(0);
}
/******************************************************************************/
/*                   Get the interleaved and encoded bits.
*******************************************************************************/
int Get_Enc_Iv_Bits()
{
 int cnt,bit,enc_bit,iv_inx;
 Enc_State=ZERO;
 for(cnt=ZERO;cnt<FRAME_SIZE;cnt++)
 {
  iv_inx=De_Iv_Map[cnt];
  bit=Bits[iv_inx];
  enc_bit=Trel_Op[Enc_State][bit];
  Enc_State=Trel_NS[Enc_State][bit];
  Sym2[cnt]=Bit_Map[enc_bit];
  Parity2[cnt]=enc_bit;
 }
// printf("\t Encoder 2 state after data bits:%d.\n\n",Enc_State);
 return(0);
}
/******************************************************************************/
/*                   Print the input bits to both encoders.
*******************************************************************************/
int Print_Input_Bits()
{
 int cnt;
 printf("\t Input bits to 1st encoder:\n\n");
 for(cnt=ZERO;cnt<FRAME_SIZE;cnt++)
  printf("\t Time:%6d Enc1 bit:%d\n",cnt,Bits[cnt]);
 printf("\n");
 return(0);
}
/******************************************************************************/
/*                            Print the symbols.
*******************************************************************************/
int Print_Symbols()
{
 int cnt;
 printf("\t Transmitted symbols:\n\n");
 for(cnt=ZERO;cnt<FRAME_SIZE;cnt++)
 {
  printf("\t Time:%6d Sym0:%+lf ",cnt,Sym0[cnt]);
  printf("Sym1:%+lf Sym2:%+lf\n",Sym1[cnt],Sym2[cnt]);
 }
 printf("\n");
 return(0);
}
/******************************************************************************/
