/******************************************************************************/
/*                                BIT VARIABLES.
*******************************************************************************/
extern int Bits[FRAME_SIZE];                             /* Information bits. */
extern int Frame_Cnt;                                         /* Frame count. */
extern int Bit_Cnt;                                             /* Bit count. */
extern int Ber;                                            /* Bit error rate. */
extern int Fer;                                          /* Frame error rate. */
extern int Frame_Err_Cnt;                        /* No. of errors in a frame. */
/******************************************************************************/
/*                             ENCODER VARIABLES.
*******************************************************************************/
extern int Enc_State;                                       /* Encoder state. */
/******************************************************************************/
/*                       MAP TO CONSTELLATION VARIABLES.
*******************************************************************************/
extern double Bit_Map[CONSTELL_SIZE];                /* Map to constellation. */
/******************************************************************************/
/*                            TRANSMITTED SYMBOLS.
*******************************************************************************/
extern double Sym0[FRAME_SIZE];                               /* Data symbol. */
extern double Sym1[FRAME_SIZE];                             /* Parity symbol. */
extern double Sym2[FRAME_SIZE];                             /* Parity symbol. */
/******************************************************************************/
/*                    VARIABLES RELATED TO INTERLEAVER.
*******************************************************************************/
extern int Iv_Map[IV_SIZE];                           /* Interleaver mapping. */
extern int De_Iv_Map[IV_SIZE];                      /* Deinterleaver mapping. */
extern unsigned short Iv_Noise_Store[PN_SIZE];          /* Stores PNS status. */
/******************************************************************************/
/*                       NOISE GENERATOR VARIABLES.
*******************************************************************************/
extern int Noise_Var_Cnt;  /* No. of noise samples used to estimate variance. */
extern unsigned short N1_Store[PN_SIZE];                /* Stores PNS status. */
extern unsigned short N2_Store[PN_SIZE];                /* Stores PNS status. */
extern unsigned short N3_Store[PN_SIZE];                /* Stores PNS status. */
extern unsigned short N4_Store[PN_SIZE];                /* Stores PNS status. */
extern double Inv_Twice_Noise_Var;    /* Inverse of twice the noise variance. */
extern double N1_Val[NVALSIZE];                  /* Contains U & G rand. var. */
extern double N2_Val[NVALSIZE];                  /* Contains U & G rand. var. */
extern double Noise_Var;                       /* Estimate of noise variance. */
/******************************************************************************/
/*                    VARIABLES RELATED TO THE TRELLIS.
*******************************************************************************/
extern int Enc_N[ENC_SIZE];                    /* Stores encoder numer. taps. */
extern int Enc_D[ENC_SIZE];                    /* Stores encoder denom. taps. */
extern int Trel_NS[NUM_STATES][NUM_INPUTS];                    /* Next state. */
extern int Trel_PS[NUM_STATES][NUM_INPUTS];                    /* Prev state. */
extern int Trel_Op[NUM_STATES][NUM_INPUTS];                       /* Outputs. */
/******************************************************************************/
/*                            BCJR VARIABLES.
*******************************************************************************/
extern int Iter;                                        /* Counts iterations. */
extern double Alpha[FRAME_SIZE][NUM_STATES];                       /* Alphas. */
extern double Beta[FRAME_SIZE][NUM_STATES];                         /* Betas. */
extern double Gamma_I[FRAME_SIZE][NUM_INPUTS];         /* Dv. intrinsic info. */
extern double Gamma_E_P1[FRAME_SIZE][NUM_INPUTS];      /* Extrinsic info: P1. */
extern double Gamma_E_P2[FRAME_SIZE][NUM_INPUTS];      /* Extrinsic info: P2. */
extern double Prob[FRAME_SIZE][NUM_INPUTS];            /* Data probabilities. */
/******************************************************************************/
