# Plot of the symbol error rates for rate-1/2 (QPSK) turbo-codes in ACGN for
# Type 3 filter.
set term postscript eps color 22
set nokey
set format y "%2.1e"
set output "qpsk.eps"
set logscale y
#set xlabel "SNR (dB)"
#set ylabel "Symbol error rate"
plot "../tc4color/tc4cdata/tc4csim.dat" t\
     "Conventional turbo code in coloured noise for Type 3 filter"\
      w lines lt 1 lw 3,\
     "../tc3color/tc3cdata/tc3csim.dat" t\
     "Predictive turbo code with 1st-order predictor for Type 3 filter"\
      w lines lt 2 lw 3,\
     "../tc3color/tc3cdata/tc3c2nd.dat" t\
     "Predictive turbo code with 2nd-order predictor for Type 3 filter"\
      w lines lt 3 lw 3,\
     "../tc4color/tc4cdata/tc4cawgn.dat" t "Conventional Turbo code in AWGN"\
      w lines lt 4 lw 3
